"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var webpack_state_1 = require('./webpack-state');
__export(require('./webpack-state'));
function hotModuleReplacement(bootloader, module, LOCAL, LOCALSTORAGE_KEY) {
    if (LOCALSTORAGE_KEY === void 0) { LOCALSTORAGE_KEY = '@@WEBPACK_INITIAL_DATA'; }
    var COMPONENT_REF = null;
    var DATA = module.hot.data;
    console.log('DATA', DATA);
    if (!DATA && LOCAL) {
        try {
            console.time('start localStorage');
            DATA = JSON.parse(localStorage.getItem(LOCALSTORAGE_KEY)) || DATA;
            console.timeEnd('start localStorage');
        }
        catch (e) {
            console.log('JSON.parse Error', e);
        }
    }
    console.time('bootstrap');
    if (document.readyState === 'complete') {
        bootloader(DATA)
            .then(function (cmpRef) { return COMPONENT_REF = cmpRef; })
            .then((function (cmpRef) { return (console.timeEnd('bootstrap'), cmpRef); }));
    }
    else {
        document.addEventListener('DOMContentLoaded', function () {
            bootloader(DATA)
                .then(function (cmpRef) { return COMPONENT_REF = cmpRef; })
                .then((function (cmpRef) { return (console.timeEnd('bootstrap'), cmpRef); }));
        });
    }
    function saveState(appState) {
        var json = appState.toJSON();
        if (LOCAL) {
            console.time('localStorage');
            localStorage.setItem(LOCALSTORAGE_KEY, JSON.stringify(appState));
            console.timeEnd('localStorage');
        }
        return json;
    }
    function beforeunload(event) {
        var appState = COMPONENT_REF.injector.get(webpack_state_1.WebpackState);
        return saveState(appState);
    }
    window.WEBPACK_HMR_beforeunload = function () {
        window.removeEventListener('beforeunload', beforeunload);
        if (LOCAL) {
            localStorage.removeItem(LOCALSTORAGE_KEY);
        }
    };
    module.hot.accept();
    window.addEventListener('beforeunload', beforeunload);
    module.hot.dispose(function (data) {
        console.time('dispose');
        var componentNode = COMPONENT_REF.location.nativeElement;
        var newNode = document.createElement(componentNode.tagName);
        // display none
        var currentDisplay = newNode.style.display;
        newNode.style.display = 'none';
        var parentNode = componentNode.parentNode;
        parentNode.insertBefore(newNode, componentNode);
        var appState = COMPONENT_REF.injector.get(webpack_state_1.WebpackState);
        var json = saveState(appState);
        Object.assign(data, json);
        COMPONENT_REF.dispose();
        newNode.style.display = currentDisplay;
        window.removeEventListener('beforeunload', beforeunload);
        console.timeEnd('dispose');
    });
}
exports.hotModuleReplacement = hotModuleReplacement;
//# sourceMappingURL=index.js.map